<!doctype html>
  <html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <title>COMP3400 mid-semester revision &mdash; live coding of previous lecture examples</title>
  <link href="https://fonts.googleapis.com/css?family=Open+Sans:400,400italic,300italic,300,600,600italic,700,700italic,800,800italic" rel="stylesheet" type="text/css">
  <link rel="stylesheet" href="https://css.1007036.casa/bootstrap.min.css" />
  <link rel="stylesheet" href="https://css.1007036.casa/font-awesome.min.css" />
  <link rel="stylesheet" href="https://css.1007036.casa/custom.css">
  </head>
  <body>
    <main>
      <div class="container-fluid">
        <div class="container my-4">
          <div class="row">
            <div class="col">
              <h1 class="display-4 text-center">
                <br>
                COMP3400 mid-semester revision
              </h1>
              <h4 class="display-6 text-center">
                <br>
                live coding of previous lecture examples
              </h4>
            </div>
          </div>
        </div>
        <div class="container">
          <div class="row">
            <div class="col">
              <ul class="list-group">
                <li class="list-group-item">
                  <span>More Haskell Syntax, Development Tools and Techniques</span>
                  <span class="float-right">
                    [<a href="{CI_PROJECT_URL}/-/blob/master/03-more-syntax-dev-techniques.hs">source</a>]
                    [<a href="{CI_PROJECT_URL}/-/blob/answers/03-more-syntax-dev-techniques.hs">answer</a>]
                  </span>
                </li>
                <li class="list-group-item">
                  <span>Data Types and Type Classes</span>
                  <span class="float-right">
                    [<a href="{CI_PROJECT_URL}/-/blob/master/04-data-types-and-type-classes.hs">source</a>]
                    [<a href="{CI_PROJECT_URL}/-/blob/answers/04-data-types-and-type-classes.hs">answer</a>]
                  </span>
                </li>
                <li class="list-group-item">
                  <span>Code Reuse</span>
                  <span class="float-right">
                    [<a href="{CI_PROJECT_URL}/-/blob/master/05-code-reuse.hs">source</a>]
                    [<a href="{CI_PROJECT_URL}/-/blob/answers/05-code-reuse.hs">answer</a>]
                  </span>
                </li>
                <li class="list-group-item">
                  <span>Abstraction, More Code Reuse and Testing</span>
                  <span class="float-right">
                    [<a href="{CI_PROJECT_URL}/-/blob/master/06-abstraction-testing.hs">source</a>]
                    [<a href="{CI_PROJECT_URL}/-/blob/answers/06-abstraction-testing.hs">answer</a>]
                  </span>
                </li>
                <li class="list-group-item">
                  <span> Monad, IO, do-notation, parsers </span>
                  <span class="float-right">
                    [<a href="{CI_PROJECT_URL}/-/blob/master/07-monad-io-parser.hs">source</a>]
                    [<a href="{CI_PROJECT_URL}/-/blob/answers/07-monad-io-parser.hs">answer</a>]
                  </span>
                </li>
              </ul>
            </div>
          </div>
        </div>
        <hr>
        <div class="text-center">
          revision
          <a href="repo">
            <code style="display: inline">
              {CI_COMMIT_SHA}
            </code>
          </a>
        </div>
      </div>
    </main>
  </body>
</html>
